\documentclass{scrarticle}
\usepackage{hyperref}
\usepackage{titling}
\usepackage{graphicx}
\usepackage{float}
\usepackage{booktabs}
\usepackage{color}
\usepackage{tikz}
\usepackage{pgfgantt}
\usepackage{rotating}
\usepackage{fancyhdr}

\renewcommand{\headrulewidth}{0pt}

\pagenumbering{arabic}
\pagestyle{fancy}
\fancyhead{}
\fancyfoot{}
\fancyfoot[R]{\thepage}



%Let's define some awesome new ganttchart elements:
\newganttchartelement{orangebar}{
    orangebar/.style={
        inner sep=0pt,
        draw=red!66!black,
        very thick,
        top color=white,
        bottom color=orange!80
    },
    orangebar label font=\slshape,
    orangebar left shift=.1,
    orangebar right shift=-.1
}

\newganttchartelement{bluebar}{
    bluebar/.style={
        inner sep=0pt,
        draw=purple!44!black,
        very thick,
        top color=white,
        bottom color=blue!80
    },
    bluebar label font=\slshape,
    bluebar left shift=.1,
    bluebar right shift=-.1
}

\newganttchartelement{greenbar}{
    greenbar/.style={
        inner sep=0pt,
        draw=green!50!black,
        very thick,
        top color=white,
        bottom color=green!80
    },
    greenbar label font=\slshape,
    greenbar left shift=.1,
    greenbar right shift=-.1
}

\newganttchartelement{graybar}{
    graybar/.style={
        inner sep=0pt,
        draw=gray!50!black,
        very thick,
        top color=white,
        bottom color=gray!80
    },
   graybar label font=\slshape,
   graybar left shift=.1,
   graybar right shift=-.1
}

\newganttchartelement{yellowbar}{
    yellowbar/.style={
        inner sep=0pt,
        draw=white,
        thick,
        top color=white,
        bottom color=white
    },
   yellowbar label font=\slshape,
   yellowbar left shift=.1,
   yellowbar right shift=-.1
}

\begin{document}
\title{Integrating IoT in a Decentralized Renting Application} %TODO: Fill in project name
\author{%TODO: Fill in your names
	Lieb, Alexander (Alexander.Lieb@online.de) 
		\and \\
          Rüdesheim, Lennard (lennard.ruedesheim@stud.tu-darmstadt.de)
%TODO uncomment for more authors
%	\and \\
%	LastName3, FirstName3
%	\and \\
%	LastName4, FirstName4
}

\input{titlepage_final_report}
\clearpage

\paragraph{Abstract.}
\begin{abstract}
	%Summarize the motivation and main concepts of your project (1/2 page). This should be an improvement of your previous abstract.

The business model of the sharing economy is based on interactions between the consumers of a platform. Popular examples for platforms in the market are Airbnb and Uber. They offer a service for users to rent their flat or a driving service. In this setting the platform provider has the power to decide who has access to his services and can demand significant fees for users. There is also a lack of privacy for the participants.

We developed a Decentralised App (DAPP) based on a smart contract at the Ethereum blockchain to allow transactions between an owner of a product and a renter, such that no platform provider is needed. Our application enables users to rent their bike. In this application we integrated an IoT device through that we reduced the effort for the users. The IoT device controls the lock of a bike and is able to locate it, such that a bike owner has an increased security. Thereby the location of the bike is also used to determine the fee for renting by computing the travel distance during a loan.
\end{abstract}

\newpage

%\textit{The length of this report (from here on) should be at least 7 pages of text (not counting pictures and diagrams). Nevertheless, we would like you to back up your explanations with graphics. The major part of your report is the concept section. This should be at least 4 pages. The implementation section can be quite short, as you will probably explain your implementation in a separate documentation.}

\section{Introduction}
%Introduce the reader to your project by explaining your motivation and goals. If there already exist other similar projects, explain the difference between your project and the others.

%vergleich mit Bogner et al und Niya (Background chapter proposal)

The business of platforms on which users can offer their privately owned products and services is called the sharing economy. The platforms enable interactions between people, which want to rent an object or service for a certain amount of time, and people, which possess objects, they want to rent or can offer a service. The sharing economy is rapidly growing in the recent years and it is unclear how this step from a culture where consumers own assets to a culture where they share access to assets via platforms influences the society \cite{MARTIN2016}.
Traditional examples for platforms like Airbnb and Uber have several drawbacks. The platform provider can control the access and block merchants. (S)he is also able to demand significant fees and there is often a lack of privacy for the participants. \cite{Bogner16}

Our approach of developing such a platform is to built a Decentralised App (DAPP) based on smart contracts on the Ethereum blockchain. The DAPP enables transactions between an product owner and a renter, such that no centralized platform provider is needed.  In this way we avoid to pay fees to the platform provider and a user has more control of their data and information \cite{Prasad18}.  Our application is a renting bike system in which we integrate an IoT device. The IoT device is able to control the lock of the bike and to locate it. This reduces the effort for a bike owner during the renting process and increases his/her security.  The location of the bike can also be used to calculate the travel distance during a loan, which enables variable renting costs per km. 

The idea to create a renting system using smart contracts is discussed in the community for a while now. Concepts are implemented by Bogner et al. \cite{Bogner16} and Niya et al. \cite{Niya17}. While \cite{Bogner16} is concentrating on the technical aspects, \cite{Niya17} also mentions the legal aspects.

        Bogner et al. \cite{Bogner16} presents a DAPP, using Smart Contracts on the Ethereum blockchain. If a customer wants to rent a product, its QR code must be scanned and the payment happens via blockchain. In this implementation, the product as an IoT device is not part of the contract. An automatic unlocking or the possibility that the device reports how much it was used and therefore calculates the cost, is missing.

        Niya et al. \cite{Niya17} presents a concept, where the contract to rent an object is made legally valid and personal data is exchanged to ensure that the other person exists and can be identified in case something malicious happens. An android app is implemented, which can either run its own ethereum client or connect to an ethereum client running on a server. For exchanging personal data, device to device communication is used. In contrast to that we focus on having an privacy preserving application in which we reduced the exchanged private data to the public keys of the users. An IoT device is not part of the contract.

 Integrating IoT Devices into the blockchain is also a hot research topic. An overview and evaluation of the competing architectures can be found in Pustišeka et al. \cite{Pus17}. Pustišeka et al. \cite{Pus17} divides the  IoT blockchain application development into two parts. The On-Chain part, where the Smart Contract and the payment happens, and the Front-End part, which is required for the user interface and by the IoT devices to interact with the On-Chain Part. The Front-End part is further divided into four possible architectures. The easiest one is to create a Stand-Alone node, where the IoT device runs a node. This enables the IoT device to directly interact with the blockchain but also requires the most resources and therefore might not be a good choice on constrained devices. The second approach is to let a server run the node including the key storage and the IoT device interacts with the corresponding server. This includes the security risk that anyone interacting with this server might also access the key store. Therefore the third possibility is to keep the key storage on the embedded device and send signed transactions to the node. While the possibilities two and three work with the web3.py library, the last possibility is to use a proprietary communication protocol. This has the advantage to ignore the existing data formats and of being able to perfectly balance the load on the devices, but also comes with an huge overhead in the development process. To reduce the security risks we choosed the third architecture for our application.

\newpage

\section{Concept}
%Explain the concepts of your project: System- and software architecture, typical workflows, security considerations, possible efficiency improvements, …. Take a special focus on explaining the projected features of your project and their benefit for your customers.
%It is not necessary that all aspects of your concept have been implemented. If you have not realized all modules of your architecture or if you have already planned further improvements without realizing them, feel free to add them to your concept as well.

%Renting System 

% erklären, warum zwei Contracts

%IoT device

%Connection between IoT device and contract (with protocol diagrams, storage of private key on the device)

% subsection

%possible attacks and countermeasures (adversarial hirer, adversarial bike owner, ..)

The idea of our Decentralized Renting Application is to connect two types of users. A user can be an owner of a bike who wants to offer his/her bike or a hirer who wants to use a bike for a certain amount of time. An illustration of our system is shown in \ref{fig:dapp}. In this section we will describe how our Renting Systems works, which functionalities are offered by the integrated IoT device and how the connection between the device and the smart contract is established. We will additionally show possible attacks against our system and describe countermeasures.


\begin{figure}[H]
    \centering
    \includegraphics[width=.7\linewidth]{img/appArchitecture.jpg} 
    \caption{Decentralized Renting Application }
    \label{fig:dapp}
\end{figure}


\subsection{Renting System} \label{sec:renting}

The main functionalities of the system are, that a bike owner can add and remove bikes, while a hirer can rent and return bikes. The system is city-based, which means, that each city has its own contract and the user can choose the city. The city contracts are registered in a so-called master contract (see figure \ref{fig:masterCity}). If there is no contract for the searched region, the user can deploy and register one by himself/herself. Since the IoT device listens for events emitted by the contract it is connected to, this city-based architecture reduces the amount of information the IoT device has to process, in contrast to an one-contract-for-everything architecture. Therefore, power consumption and the time needed for processing a new block by the application is decreased significantly.

\begin{figure}[H]
    \centering
    \includegraphics[width=.95\linewidth]{img/contracts.jpg} 
    \caption{Master and City Contract Architecture}
    \label{fig:masterCity}
\end{figure}

The interactions between a bike owner and the city contract is shown in figure \ref{fig:AddProtocol} and \ref{fig:RemoveProtocol}. For adding a bike the owner has to send the wished base price, the price per km and the refund for hiring to the contract and also pay an owner refund. The owner refund prevents the user from behaving maliciously, since (s)he can be punished by loosing it. After the city contract has sent an event, which includes the assigned bike ID, the bike is available to the hirers. If the bike owner wants to remove the bike from the application (s)he just has to send the bike ID to the system, which checks if the sender really owns the bike,  and sends his/her refund back.  

\begin{figure}[H]
    \centering
    \includegraphics[width=.75\linewidth]{../Protocol/adding_bike_protocol.pdf} 
    \caption{Protocol for adding a bike}
    \label{fig:AddProtocol}
\end{figure}


\begin{figure}[H]
    \centering
    \includegraphics[width=.4\linewidth]{../Protocol/removing_bike_protocol.pdf} 
    \caption{Protocol for removing a bike}
    \label{fig:RemoveProtocol}
\end{figure}

To rent a bike, a hirer has a look on the city contract to get the information about the available bikes (see figure \ref{fig:RentProtocol}). This is done using view functions without any gas cost. Based on these information (s)he can select a bike and sends the bike ID of the wished bike and the refund plus the base price to the contract. The city contract emits an event, which is recognized by the IoT device. The IoT device then opens the lock of the bike and starts measuring the travel distance.


\begin{figure}[H]
    \centering
    \includegraphics[width=.99\linewidth]{../Protocol/rent_bike_protocol.pdf} 
    \caption{Protocol for renting a bike}
    \label{fig:RentProtocol}
\end{figure}

After the renting time the hirer has to send the bike ID to the city contract to return the bike (see figure \ref{fig:ReturnProtocol}). The city contract then emits an event which is registered by the IoT device, so that the IoT device can close the bike and send the traveled distance to the city contract. The costs for renting can then be computed and the hirer gets the corresponding money back. The returning will be denied if the maximum renting time of one day is exceeded.


\begin{figure}[H]
    \centering
    \includegraphics[width=.95\linewidth]{../Protocol/return_bike_protocol.pdf} 
    \caption{Protocol for returning a bike}
    \label{fig:ReturnProtocol}
\end{figure}



\subsection{IoT Device}
The IoT device is able to get its current location, to control the lock of the bike and to access the internet. To get the location of the bike the device is connected to a GPS module, which provides the latitude and longitude. To establish a connection to the internet, the IoT device also has an LTE stick. The bike lock itself consists of a stepmotor, which can be controlled by the IoT device, and a solid iron rod. A picture of the lock is shown in figure \ref{fig:BikeLock}.

\begin{figure}[H]
    \centering
    \includegraphics[width=.6\linewidth]{../Lock_Img/IMG_9720.JPG} 
    \caption{Bike Lock}
    \label{fig:BikeLock}
\end{figure}

With this functionalities the integration of the IoT device in our application makes the renting process for bike owners more secure and reduces the effort. The normally necessary communication between a hirer and an owner about the location of the bike and how to access it is bypassed, since the bike can send its location to the contract and the contract is able to control the bike lock. The possibility to access the location of the bike makes it also possible to charge a distance based price and increase the security for the bike owner, since (s)he knows a recent position of the bike. The control of the bike lock also prevents simple steal attempts.


\subsection{Connection between the IoT device and the contract} 

A bike and also the IoT device of a bike has to be assigned to a certain city. The IoT device is able to establish a connection to the corresponding city contract and asks for its bike ID. When the IoT device knows the bike ID, it can ask for the bike state and gets as answer the stored information about the bike. It checks the position of the bike and sends, if necessary, corrected latitude and longitude values back to the city contract. While the request of the ID and the request of the stored information is done as view functions and does not cost any gas, the correction of the location is a signed transaction, which will be included in the blockchain. The procedure between the city contract and the IoT device is shown in figure \ref{fig:ConnectionProtocol}. After that the IoT device listens for the events of the smart contracts and reacts as described in section \ref{sec:renting}.



\begin{figure}[H]
    \centering
    \includegraphics[width=.6\linewidth]{../Protocol/IoT_contract_connection_protocol.pdf} 
    \caption{Connection between the IoT device and the city contract}
    \label{fig:ConnectionProtocol}
\end{figure}

\subsection{Possible attacks and countermeasures}
In this section we describe possible physical attacks, software attacks against the IoT device and attacks against the smart contracts. We also show how the system can be secured against those attacks.

\subsubsection{Physical attacks}
To get physical access to the bike is easy for an attacker, since the location is publicly available. Attackers can for example try to break or remove the lock or to manipulate the IoT device. Not all of these physical attacks against the bike can be prevented, but should be made time expensive and unattractive. Since a bike theft is usually a person who acts economically, there is no need to secure against all physical attacks in an absolute manner. If it is economically not reasonable to steal this bike, for example because it takes to long and the risk of being caught is higher than when stealing other bikes, it can already be considered as secure.

Therefore the IoT device should be placed in a secure case, such that not even the bike owner has easily access to it. We decided that the building of such a case is out of scope for our project, since we want to focus more on computer scientific aspects of our application. Nevertheless, it is of course possible to build such a case.

Attacker could also attack the power supply of the IoT device to force a periodically reconnection of it to the contract. Therefore, we implemented the connection setup to not consume any gas.

GPS jamming and GPS spoofing can be quite easily done. While GPS jamming can be easily seen by a lost signal, GPS spoofing is hard to detect and countermeasures against it are still discussed in the community, without a working result any time soon. Therefore we decided to develop countermeasures against jamming the GPS signal only. When the signal is jammed during the boot process of the device, is effectively a denial of service attack since the application waits, until it gets values. A DOS attack in this context cannot be prevented, since to DOS a bike it would be enough to simply destroy the bicycle tires. Whether the adversary destroys the bicycle tires or jams the GPS signal has the same effect and to create a more complex countermeasure against GPS jamming is therefore not needed, as long as it is that easy to DOS a bike. If the GPS signal is jammed during the bike is rented, the bike should multiply the time, where no GPS signal is available, with a preconfigured speed to get the travel distance. Due to timing issues, this is not implemented, but of course easily possible. If the GPS signal is jammed during the bike is not rented, there is no further effect.

Jamming the internet connection, or placing the bike somewhere, where is no LTE connection, is quite simple for an attacker (at least in Germany). Therefore, this case should be considered, too. If there is no internet connection when the application starts, the bike lock cannot be unlocked, resulting, once again, into a Denial of Service. When there is no internet connection while the bike is rented, the bike cannot be locked, and the hirer cannot return the bike. Therefore the hirer refund is kept by the contract. To circumvent this problem, regarding the availability, a feature where the hirer can use his/her smartphone to connect to the bike lock, and send the transactions to the blockchain would be nice. Also the usage of a Low-Power Wide Area Network (LP-WAN) like the widely deployed LoRaWAN, could be considered.

Replacing the SD card of the bikelock and therefore starting malicious software can be prevented by two possibilities. On the one hand, the SD card slot can be physically protected, e.g. by soldering the SD card into the slot or by creating a case which prevents the access to the slot. On the other hand, a secure boot can prevent the IoT device from starting malicious software. For this, a board with a secure boot supporting firmware would be needed.

As last physical attack, a malicious hirer might place the bike in another city, thus making the bike unusable. This can be prevented by the city contract if it supports the feature, that the bike can only be returned, when the IoT device announces its position within a certain area. 

\subsubsection{Software attacks against the IoT device}

Software attacks against the IoT device can be divided into two categories. There are attacks against the software, which are running when the IoT device is off and attacks, when the IoT device is running.

When the IoT device is off, an adversary can try to get an image of the memory and extract information out of it. This can include the secret key, used for signing transactions. To prevent this, the image should be encrypted, e.g. by using secure boot or a secure storage. The implementation of this was started, but not finished.

When an attacker makes his/her way into the device, while the IoT device is running, (s)he can run a lot of attacks. Opening the bike lock would be just a simple function call and also the private key can be freely used. To prevent this, the first step has to be to switch off all possible shells of the device, including serial connections like UART or open SSH ports. A firewall, closing all ports, is a must-have. After this, only the connections to the outside world have to be considered. While the internet connection can be tricked into getting malicious blocks, the GPS signal can hardly be tricked into running an attack. Therefore, this case should not be considered. Trusting malicious blocks should be prevented by first checking a few blocks, before trusting them. The overhead of creating blocks is that large, that a few blocks already have higher costs than several bikes and it is therefore not economical to run such an attack. This is not implemented yet.

\subsubsection{Software attacks against the smart contracts}

There are two possible attacks against the smart contract, we consider. The first attack is about the hirer not returning the bike. In this case the fund, the hirer placed, is kept and buying a bike is cheaper. Nevertheless, the owner of the bike is not allowed to take the fund, to prevent the second attack, which is about placing fake bikes. A bike owner can trick a hirer into renting a non-existent bike by placing two bikes. While one is real, the other is not. If the hirer rents the fake bike, the fake bike mirrors the activity to the real bike (it acts as relay). Therefore the bike lock of the real bike lock opens and the hirer does not expect to happen something malicious, as long as the bike owner prevents the double-check of the address. When the hirer wants to return the bike, the fake bike stops the relay and while the bike lock closes, the hirer does not get his/her refund back. This attack is prevented by two different countermeasures. At first, the bike owner has no possibility to get the refund of the hirer. Therefore, there is no financial advantage of doing so. Second, the owner has to place a owner refund. This refund is returned, when the bike is removed from the contract. While the bike is rented, it cannot be removed, and when the bike is never returned, the owner looses this refund. Therefore, by running this attack, the malicious bike owner looses the refund (s)he paid to place the fake bike.

\newpage

\section{Implementation}
%In this section you should describe which parts of your concept and which features have been implemented and how you have implemented them, e.g. the tools and libraries you have used to realize different modules of your architecture.
%We do not want you to provide a documentation of your source code here. If your supervisor wants you to submit a documentation, you should provide it in a separate document.
%gas costs??

In this chapter, a short overview of the different modules is given. It starts with a brief description of the smart contract, goes on with a short look on the user interface, describes the bike lock and finally has a short view on what was done to start the implementation of a secure storage. The software is freely available at the \href{https://git.rwth-aachen.de/a.lieb/bc-praktikum-group2}{TU Gitlab}. For more information about the implementation, please have a look at the repository.

\subsection{Smart Contracts}

As already mentioned, there are two smart contracts implemented. For this, we used truffle and solidity.

The master contract is quite short, it only consists of a datastructure, which contains some information about the city contracts, view functions for getting these information and a register function, to register new city contract instances.

The city contract is more complex. It consists of a datastructure for storing the bikes and several functions. There are view functions to get information about the stored bikes, and functions for the necessary interaction, like renting, returning, adding, and removing a bike. There is also a datastructure for handling the refunds of all users, including a function for getting them back.

\subsection{User Interface}

The user interface is mainly written in HTML and Javascript. Some example screenshots are shown in figure \ref{fig:MasterContract} and figure \ref{fig:CityContract}. It uses metamask for the connection to the rinkeby blockchain and enables the user to choose a city and interacts with it.

\begin{figure}[H]
    \centering
    \includegraphics[width=.6\linewidth]{img/Screenshot_Master_UI.png} 
    \caption{The user interface of a master contract}
    \label{fig:MasterContract}
\end{figure}


\begin{figure}[H]
    \centering
    \includegraphics[width=.6\linewidth]{img/Screenshot_City_UI.png} 
    \caption{The user interface of a city contract}
    \label{fig:CityContract}
\end{figure}

\subsection{IoT Device and bike lock}

The IoT device mainly consists of a raspberry pi 4, a serial connection to the bike lock, a NEO 6-M GPS module, a LTE stick and the corresponding software. The bike lock basically consists of a step motor and a solid iron rod.

\subsubsection{IoT Device}

For simplicity, a raspberry pi 4 is used for the showcase. It runs python software, which handles the connection to the GPS module. The module itself is connected through a serial connection. It sends NMEA sentences to the raspberry pi, which contain the GPS information. The raspberry pi uses these information to locate itself, to measure traveled distances and correct location information at the blockchain.

The bike lock is connected through GPIO pins. The software stores the information, whether the bike lock is open or closed in a separate file. Therefore the information is still valid, when the power supply is lost.

The connection to the rinkeby blockchain is done by using the web3.py library and an infura account. On startup, the software uses view functions to get its state from the blockchain. When it has to send transactions, it uses the locally stored key to sign them and sends them through infura to the blockchain.

\subsubsection{Bike Lock}

The bike lock is shown in figures \ref{fig:BikelockAllParts} to \ref{fig:BikelockFinished}. It basically consists of a step motor and a solid iron rod. Into the solid iron rod, we gouged two holes. In one hole, we cut a female screw thread, while the step motor is plugged into the other hole. When a screw is turned into the first hole, it fixes the step motor, making it possible to move the bikelock.

\begin{figure}[H]  
  \begin{minipage}[b]{0.5\linewidth}
    \centering
    \includegraphics[width=.95\linewidth]{img/first.jpg} 
    \caption{All parts of the bikelock}
    \label{fig:BikelockAllParts}
    \vspace{4ex}
  \end{minipage}%%
  \begin{minipage}[b]{0.5\linewidth}
    \centering
    \includegraphics[width=.95\linewidth]{img/second.jpg} 
    \caption{Iron Rod is placed} 
    \vspace{4ex}
  \end{minipage} 
  \begin{minipage}[b]{0.5\linewidth}
    \centering
    \includegraphics[width=.95\linewidth]{img/third.jpg} 
    \caption{Iron Rod is placed, frontal} 
    \vspace{4ex}
  \end{minipage}%% 
  \begin{minipage}[b]{0.5\linewidth}
    \centering
    \includegraphics[width=.95\linewidth]{img/fourth.jpg} 
    \caption{Bikelock is finished}
    \label{fig:BikelockFinished}
    \vspace{4ex}
  \end{minipage}
\end{figure}

\subsubsection{Secure Storage}

There was not enough time, to get the secure storage for the private key running. This part was always mentioned as a ``nice-to-have'' feature and in this section, we want to provide the experience we had with it to the reader.

Maybe the most important information is, that the ARM TrustZone is not implemented in the hardware of the raspberry pi. As long as a raspberry pi is used, this can only be a showcase, not providing any true security. Therefore, before going on, the board should be switched (we already touched the limits of a raspberry pi several times anyway). We decided to use the open source OP-TEE project for several reasons. Depending on the board and the manufacturer, this framework provides not only a simple secure storage implementation, but also a secure boot feature which can be really helpful as already mentioned several times.

In our case, OP-TEE is available for the raspberry pi 3 only (in a non-secure way). Therefore we switched to a raspberry pi 3 and checked out the buildroot based framework. This also includes the fact, that we had to leave raspbian and build a custom rootfs. We added the web3.py library, the geopy library, and the IoT Software to the build packages. As usual in buildroot, each package consists of a Makefile and a Config.in. In the Makefile, the user can define, where the system can get the source and how it should be built. While the geopy library and the web3.py library are cloned from git, the IoT Software is sourced from a local folder. It is very important to enable SSL in the pkg-python.mk file of buildroot and to install the cryptodomex library to make OP-TEE building. While the secure storage example is working at our raspberry pi and there is a shell provided through the UART interface (a UART to USB dev board is needed), the web3.py library has a lot of dependencies, which must be installed manually. This is quite time consuming and therefore the point, where we got stuck.


\newpage

\section{Project Management}
%Explain your project management concept and project timeline. The explanation can be similar to the one of your proposal, in particular it should cover the same aspects. However, you should update it according to your actual project execution.
%Please visualize your project timeline, e.g., via a Gantt diagram, and list the responsibilities of your team members in regard to the different tasks that have been executed during your project.


%hier visualize Project timeline und bei reflection visual comparison of initial project plan and the actual plan

This chapter is about how the project was initially planned. A comparison to what actually happened can be seen in chapter \ref{section:Reflection}.

For our project we choosed an iterative and flexible process, leading to the ability to deal with unexpected events and problems during the implementation. As it is shown later, there have been several unexpected problems and therefore the agile methods, which are described in more detail in the following, were helping us to successfully finish this project. 

\subsection{Management Methodology}

Our Management Methodology is based on Scrum and adapted to a two person team. We described the features of our project in the form of User Stories. These User Stories are written from the perspective of an end user of the software and contain an acceptance criteria to make it measurable whether a User Stories is finished or not. To get an overview of the needed features, the User Stories were stored in a Product Backlog. 
	
We divided the project duration into sprints with the length of two weeks. Before each sprint we had a sprint planing meeting where we decided which User Stories we wanted to implement in the next sprint. These Users Stories were then moved to the Sprint Backlog. After a sprint we had a Sprint Review meeting in which the implemented features were presented and we decided which User Stories were completed. Additionally we did Code Reviews for the newly added code. Five minutes of this meeting were reserved to exchange personal feedback about the Software Engineering Process. The last sprint was evaluated and improvements for the next sprint were discussed. %TODO: habe wir dafür ein Beispiel

To measure the progress of the whole project we defined milestones. Each User Story was assigned to one of these milestones. To store the User Stories and Milestones we used the Gitlab Issue Boards feature with which we were able to define lists for the Product Backlog, the Sprint Backlog, and for the finished User Stories.


\subsection{Project Plan}

The original project plan can be seen in Figure \ref{fig:firstPlan}, while the assignment of each User Story to a Milestone can be seen in Table \ref{tab:mile}. We defined three main milestones we wanted to achieve in our project.

To fulfill the first milestone, we wanted to have a working renting system. By that we mean to have a working smart contract system, where users are able to add, remove, rent, or return a bike.

Our second milestone was that our IoT device should be able to show GPS information to a connected user. It also should get a connection to the internet via LTE stick and be able to open and close the lock.

After the final milestone, we wanted the IoT device to have a connection to the contract, such that the contract is able to open and close the lock and gets the location and the travel distance of the bike from the IoT device.

%TODO: responsibilites of team members

\subsection{Motivation for the management methodology}

With the chosen management methodology we were able to repeatedly inspect the actual working software after each sprint. Through this we easily integrated new requirements into the project, enabling a creative process. The milestones helped us to have our goals for the project in mind and enabled the ability to notice time problems for the project early.  

The code reviews helped every team member to understand not only his added parts of the project, but the whole project. This made it easier to help each other, when problems occurred.

\begin{table}[H]
  \centering
 \begin{tabular}{p{4cm}p{5cm}p{5cm}}
\toprule
\textbf{Milestones} & \textbf{User Stories}\\
\midrule
\textbf{Working \linebreak Renting System} & US1: User can add a bike\\  
  &  \\
  &US2: User is able to rent a bike\\
  &\\
  &US3: User is able to release a bike\\
  \midrule
  \textbf{IoT device is working} & US6: User can get GPS data from RPI\\
  & \\
  &US4: RPI can access the LTE Stick\\
  &\\  
  &US5: The RPI can lock the bike\\
  \midrule
  \textbf{IoT device is connected to the \newline contract} & US7: Smart Contract locks the bike when it is released\\
  & US8: Bike posts the distance it has traveled \\
  & \\
  & US9: User is able to unlock the bike through the Smart Contract\\
\bottomrule
 \end{tabular}
 \caption{Project Milestones}  \label{tab:mile}
\end{table}
\begin{minipage}{0.9\linewidth}
\centering
\begin{sideways}
\begin{ganttchart}[
    hgrid style/.style={black, dotted},
    vgrid={*5{black,dotted}, *1{white, dotted}, *1{black, dashed}},
    x unit=2mm,
    y unit chart=7.5mm,
    y unit title=10mm,
    time slot format=isodate,
    group label font=\bfseries \Large,
    link/.style={->, thick}
    ]{2020-04-27}{2020-07-26}
    \gantttitlecalendar{month=name, week}\\

    \ganttgroup[
        group/.append style={fill=orange}
    ]{Milestone 1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US1
    ]{US1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US2
    ]{US2}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US3
    ]{US3}{2020-04-27}{2020-05-11}\\ [grid]


    \ganttgroup[
        group/.append style={fill=blue}
    ]{Milestone 2}{2020-05-11}{2020-05-25} \\[grid]
    \ganttbluebar{US4}{2020-05-11}{2020-05-25}\\ [grid]
    \ganttbluebar{US5}{2020-05-11}{2020-05-25} \\[grid]
    \ganttbluebar{US6}{2020-05-11}{2020-05-25} \\[grid]

    \ganttgroup[
        group/.append style={fill=green}
    ]{Milestone 3}{2020-05-25}{2020-06-08} \\[grid]
    \ganttgreenbar{US7}{2020-05-25}{2020-06-08}\\ [grid]
    \ganttgreenbar{US8}{2020-05-25}{2020-06-08} \\[grid]
    \ganttgreenbar{US9}{2020-05-25}{2020-06-08} \\[grid]

  %\ganttgroup[
   %     group/.append style={fill=yellow}
   % ]{Secure Storage}{2020-06-22}{2020-07-12} \\[grid]
 

    \ganttgroup[
        group/.append style={fill=gray}
    ]{Submissions}{2020-04-27}{2020-07-19} \\[grid]
    \ganttgraybar{Progress Report 1}{2020-05-18}{2020-05-24}\\ [grid]
    \ganttgraybar{Progress Report 2}{2020-06-15}{2020-06-21} \\[grid]
    \ganttgraybar{Final Report}{2020-06-22}{2020-07-19} \\[grid]
\end{ganttchart}
\end{sideways}
\captionof{figure}{First Project Plan} \label{fig:firstPlan}
\end{minipage}

\section{Reflection}\label{section:Reflection}
%Please reflect your project, both in regard to your project management and the execution of your project. Try to answer the following questions:
%\begin{itemize}
%	\item What did go well?
%	\item What did not go well?
%	\item What would you do different if you could start over?
%	\item How did your plan, methodic and management concept change during the project?
%	\begin{itemize}
%		\item If your project plan changed during the project execution, it might be interesting to have a visual comparison of your initial project plan and the actual timeline of your implementation.
%		\item Have you changed your concepts (e.g., software architecture) during implementation, e.g., due to unexpected problems?
%	\end{itemize}
%\end{itemize}

%ideen: - burndown charts nicht benutzt, da zu wenig user stories pro milestone und somit nicht wirklich notwendig, um überblick zu bekommen


This chapter reflects the project. It compares what was planned to what actually happened.

\subsection{Project Management}

In contrast to the original plan in figure \ref{fig:firstPlan}, the executed plan can be seen in figure \ref{fig:plan}. Maybe the most important problems, which occurred during the project, were the delayed delivery of the step motor and the not working LTE stick. As it can be seen in the figures, our agile methodology enabled the possibility to reschedule certain User Stories and therefore, the delivery problems did not result in loosing much time. We had to move the corresponding User Stories 4 and 5 to a later sprint. For the functionality of controlling the bike lock by the contract, we also needed the working bike lock, so the User Stories 7 and 9 also hat to be moved the next sprint. The agile methodology was working very well here.

In opposite to the successful sprint meetings, we stopped using the Burn Down Charts, due to the fact, that the project had not enough members and subprojects to really loose the overview. Therefore this was a case of overengineering.

\subsection{Project Execution}

Most of the time, the project execution worked well.

In the first milestone, the architecture of using two distinct contracts has paid off, since this leads to a reduced workload of the IoT device. The city contract provides a lot of features and we were using design patterns like ``Pull over Push''.

During the implementation of the second milestone, we suffered from the delivery problems. Nowadays, we would like to get rid of the LTE stick and use a smartphone app instead. A connection between the IoT device and the smartphone is easily done, e.g. via bluetooth. The device could just send the signed transactions via bluetooth to the smartphone and the smartphone could act as relay. This way, the problems regarding a broken internet connection could have been avoided. Also another board should have been used, which has the capabilities to run OP-TEE in a secure way. A list to start can be found in chapter 1.6 of the OP-TEE documentation \cite{opteedoc}.

After we had implemented the third milestone, which was also running well, Sebastian Stammler mentioned in the progress presentation the possibility to use view functions instead of transactions. After we had changed the contracts and the protocols, we now use view functions at certain places, which is easily possible and saves gas. We would like to thank again for this hint.

\begin{minipage}{\linewidth}
\centering
\begin{sideways}

\begin{ganttchart}[
    hgrid style/.style={black, dotted},
    vgrid={*5{black,dotted}, *1{white, dotted}, *1{black, dashed}},
    x unit=2mm,
    y unit chart=7.5mm,
    y unit title=10mm,
    time slot format=isodate,
    group label font=\bfseries \Large,
    link/.style={->, thick}
    ]{2020-04-27}{2020-07-26}
    \gantttitlecalendar{month=name, week}\\

    \ganttgroup[
        group/.append style={fill=orange}
    ]{Milestone 1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US1
    ]{US1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US2
    ]{US2}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US3
    ]{US3}{2020-04-27}{2020-05-11}\\ [grid]


    \ganttgroup[
        group/.append style={fill=blue}
    ]{Milestone 2}{2020-05-11}{2020-06-22} \\[grid]
    \ganttbluebar{US4}{2020-05-25}{2020-06-08}\\ [grid]
    \ganttbluebar{US5}{2020-06-08}{2020-06-22} \\[grid]
    \ganttbluebar{US6}{2020-05-11}{2020-05-25} \\[grid]

    \ganttgroup[
        group/.append style={fill=green}
    ]{Milestone 3}{2020-05-25}{2020-06-22} \\[grid]
    \ganttgreenbar{US7}{2020-06-08}{2020-06-22}\\ [grid]
    \ganttgreenbar{US8}{2020-05-25}{2020-06-08} \\[grid]
    \ganttgreenbar{US9}{2020-06-08}{2020-06-22} \\[grid]

  \ganttgroup[
        group/.append style={fill=yellow}
    ]{Secure Storage}{2020-06-22}{2020-07-12} \\[grid]
 

    \ganttgroup[
        group/.append style={fill=gray}
    ]{Submissions}{2020-04-27}{2020-07-19} \\[grid]
    \ganttgraybar{Progress Report 1}{2020-05-18}{2020-05-24}\\ [grid]
    \ganttgraybar{Progress Report 2}{2020-06-15}{2020-06-21} \\[grid]
    \ganttgraybar{Final Report}{2020-06-22}{2020-07-19} \\[grid]
    
      

\end{ganttchart}

\end{sideways}
\captionof{figure}{Project Plan} \label{fig:plan}
\end{minipage}

\section{Conclusion}
%In this section, you are supposed to assess your goal attainment and discuss advantages and disadvantages (if any) of your result. Additionally, you should provide an overview of open problems and the next steps that should be taken by someone continuing with the project.

Our Decentralised Renting Application enables rental transactions between users, such that no centralized platform provider is needed. Therefore, unlike in traditional companies in the sharing economy, no one can control the access to the platform, is able to demand significant fees or can collect large amount of private data (as long as the public keys are not linkable). The integration of the IoT device reduces the effort for a bike owner, since it reduces the normally necessary communication between a hirer and an owner about the location of the bike and how to access it. It also makes the renting process more secure considering that the bike owner can access the location of the bike and the bike lock can be controlled by the smart contract.

The next step to make the system usable is to build a secure case for the IoT device to prevent simple steal attempts of the bike and to prevent easy manipulation of the device. It is also necessary to increase the security of the private key, which is stored on the IoT device. For this we recommend the usage of a different board.

Since there is no information exchanged between the bike owner and a hirer except for the public key, there is currently no way to communicate for them. This could be useful in case of connection problems of the IoT device or if the hirer wants to inform the owner about damages to the bike.

We would like to thank Lisa Eckey and David Kretzler for their support throughout the project.



\newpage
\bibliographystyle{unsrt}
\bibliography{ref}

\end{document}
